searchData={"items":[{"type":"module","title":"FatEcto.Pagination.Helper","doc":"Provides utility functions for FatEcto, including handling pagination limits, skip values,\ndynamic binding, and preloading associations.","ref":"FatEcto.Pagination.Helper.html"},{"type":"function","title":"FatEcto.Pagination.Helper.get_limit_bounds/1","doc":"Returns the maximum and default limit values based on the provided options.","ref":"FatEcto.Pagination.Helper.html#get_limit_bounds/1"},{"type":"function","title":"Parameters - FatEcto.Pagination.Helper.get_limit_bounds/1","doc":"- `options`: A keyword list or map containing `max_limit` and `default_limit`.","ref":"FatEcto.Pagination.Helper.html#get_limit_bounds/1-parameters"},{"type":"function","title":"Examples - FatEcto.Pagination.Helper.get_limit_bounds/1","doc":"iex> FatEcto.Pagination.Helper.get_limit_bounds(max_limit: 50, default_limit: 10)\n    {50, 10}","ref":"FatEcto.Pagination.Helper.html#get_limit_bounds/1-examples"},{"type":"function","title":"FatEcto.Pagination.Helper.get_limit_value/2","doc":"Extracts and validates the limit value from the given parameters.","ref":"FatEcto.Pagination.Helper.html#get_limit_value/2"},{"type":"function","title":"Parameters - FatEcto.Pagination.Helper.get_limit_value/2","doc":"- `params`: A keyword list containing the `:limit` value.\n- `options`: A keyword list or map containing `max_limit` and `default_limit`.","ref":"FatEcto.Pagination.Helper.html#get_limit_value/2-parameters"},{"type":"function","title":"Examples - FatEcto.Pagination.Helper.get_limit_value/2","doc":"iex> FatEcto.Pagination.Helper.get_limit_value([limit: 15], max_limit: 50, default_limit: 10)\n    {15, []}","ref":"FatEcto.Pagination.Helper.html#get_limit_value/2-examples"},{"type":"function","title":"FatEcto.Pagination.Helper.get_skip_value/1","doc":"Extracts and validates the skip value from the given parameters.","ref":"FatEcto.Pagination.Helper.html#get_skip_value/1"},{"type":"function","title":"Parameters - FatEcto.Pagination.Helper.get_skip_value/1","doc":"- `params`: A keyword list containing the `:skip` value.","ref":"FatEcto.Pagination.Helper.html#get_skip_value/1-parameters"},{"type":"function","title":"Examples - FatEcto.Pagination.Helper.get_skip_value/1","doc":"iex> FatEcto.Pagination.Helper.get_skip_value(skip: 20)\n    {20, []}","ref":"FatEcto.Pagination.Helper.html#get_skip_value/1-examples"},{"type":"behaviour","title":"FatEcto.Pagination.Paginator","doc":"Provides pagination functionality for Ecto queries.\n\nThis module can be used to paginate query results by specifying `limit` and `skip` parameters.\nIt also supports counting the total number of records for pagination metadata.","ref":"FatEcto.Pagination.Paginator.html"},{"type":"behaviour","title":"Usage - FatEcto.Pagination.Paginator","doc":"defmodule Fat.MyContext do\n      use FatEcto.Pagination.Paginator, repo: Fat.Repo, default_limit: 10, max_limit: 100\n\n      # Custom functions can be added here\n    end\n\nNow you can use the `paginate/2`, `paginator/3`, and `paginate_get_records/3` functions within `Fat.MyContext`.","ref":"FatEcto.Pagination.Paginator.html#module-usage"},{"type":"function","title":"FatEcto.Pagination.Paginator.__after_compile__/2","doc":"Callback function that runs after the module is compiled.","ref":"FatEcto.Pagination.Paginator.html#__after_compile__/2"},{"type":"callback","title":"FatEcto.Pagination.Paginator.aggregate/1","doc":"","ref":"FatEcto.Pagination.Paginator.html#c:aggregate/1"},{"type":"callback","title":"FatEcto.Pagination.Paginator.count_query/1","doc":"","ref":"FatEcto.Pagination.Paginator.html#c:count_query/1"},{"type":"callback","title":"FatEcto.Pagination.Paginator.data_query/3","doc":"","ref":"FatEcto.Pagination.Paginator.html#c:data_query/3"},{"type":"behaviour","title":"FatEcto.Pagination.V2Paginator","doc":"Behaviour and implementation for robust Ecto query pagination.","ref":"FatEcto.Pagination.V2Paginator.html"},{"type":"behaviour","title":"Usage - FatEcto.Pagination.V2Paginator","doc":"defmodule MyApp.MyPaginator do\n      use FatEcto.Pagination.V2Paginator,\n        repo: MyApp.Repo,\n        default_limit: 20,\n        max_limit: 100\n\n      # Optional overrides\n      def count_records(query) do\n        # Custom counting logic\n      end\n    end","ref":"FatEcto.Pagination.V2Paginator.html#module-usage"},{"type":"callback","title":"FatEcto.Pagination.V2Paginator.count_records/1","doc":"Required callback for counting records in a query.","ref":"FatEcto.Pagination.V2Paginator.html#c:count_records/1"},{"type":"callback","title":"FatEcto.Pagination.V2Paginator.paginate/2","doc":"Required callback for paginating a query.","ref":"FatEcto.Pagination.V2Paginator.html#c:paginate/2"},{"type":"behaviour","title":"FatEcto.Query.Buildable","doc":"Builds Ecto queries after filtering fields based on user-provided filterable and overrideable fields.\n\nThis module extends FatDynamicsBuildable to work directly with Ecto queries, applying conditions\nto an existing query rather than just building dynamics.","ref":"FatEcto.Query.Buildable.html"},{"type":"behaviour","title":"Options - FatEcto.Query.Buildable","doc":"- `filterable`: A map of fields and their allowed operators. Example:\n    [\n      id: [\"$EQUAL\", \"$NOT_EQUAL\"],\n      name: [\"$ILIKE\"]\n    ]\n- `overrideable`: A list of fields that can be overridden. Example:\n    [\"name\", \"phone\"]\n- `ignoreable`: A map of fields and their ignoreable values. Example:\n    [\n      \"name\" => [\"%%\", \"\", [], nil],\n      \"phone\" => [\"%%\", \"\", [], nil]\n    ]","ref":"FatEcto.Query.Buildable.html#module-options"},{"type":"behaviour","title":"Example Usage - FatEcto.Query.Buildable","doc":"defmodule FatEcto.Query.HospitalQueryBuilder do\n      use FatEcto.Query.Buildable,\n        filterable: [\n          id: [\"$EQUAL\", \"$NOT_EQUAL\"]\n        ],\n        overrideable: [\"name\", \"phone\"],\n        ignoreable: [\n          name: [\"%%\", \"\", [], nil],\n          phone: [\"%%\", \"\", [], nil]\n        ]\n\n      import Ecto.Query\n\n      def override_buildable(query, \"name\", \"$ILIKE\", value) do\n        from(q in query, where: ilike(fragment(\"(?)::TEXT\", q.name), ^value)\n      end\n\n      def override_buildable(query, \"phone\", \"$ILIKE\", value) do\n        from(q in query, where: ilike(fragment(\"(?)::TEXT\", q.phone), ^value)\n      end\n\n      def override_buildable(query, _, _, _) do\n        query\n      end\n\n      # Optional: Override after_buildable to perform custom processing on the final query\n      def after_buildable(query) do\n        IO.puts(\"Do something on final query\")\n        query\n      end\n    end","ref":"FatEcto.Query.Buildable.html#module-example-usage"},{"type":"callback","title":"FatEcto.Query.Buildable.after_buildable/1","doc":"Callback for performing custom processing on the final query.\n\nThis function is called at the end of the `build/3` function. The default behavior is to return the query,\nbut it can be overridden by the using module.","ref":"FatEcto.Query.Buildable.html#c:after_buildable/1"},{"type":"callback","title":"FatEcto.Query.Buildable.override_buildable/4","doc":"Callback for handling custom filtering logic for overrideable fields with query support.\n\nThis function acts as a fallback for overrideable fields. The default behavior is to return the query,\nbut it can be overridden by the using module.","ref":"FatEcto.Query.Buildable.html#c:override_buildable/4"},{"type":"module","title":"FatEcto.Query.Builder","doc":"Builds Ecto queries from a structured query map.\nUsed by FatQueryBuildable for query building with query callbacks.","ref":"FatEcto.Query.Builder.html"},{"type":"function","title":"FatEcto.Query.Builder.build/4","doc":"","ref":"FatEcto.Query.Builder.html#build/4"},{"type":"module","title":"FatEcto.Query.Dynamics.BtwInContains","doc":"Provides dynamic query builders for common Ecto operations, such as filtering by ranges (`between`),\nmembership (`in`), and JSONB containment (`contains`).\n\nThis module is designed to simplify the creation of dynamic queries for Ecto schemas, particularly\nwhen dealing with complex filtering conditions.","ref":"FatEcto.Query.Dynamics.BtwInContains.html"},{"type":"module","title":"Example Usage - FatEcto.Query.Dynamics.BtwInContains","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.between_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years > ^2 and q.experience_years < ^5)\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#module-example-usage"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.between_dynamic/2","doc":"Builds a dynamic query where a field's value is between two provided values (exclusive).","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.between_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of two values representing the range.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.between_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.between_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years > ^2 and q.experience_years < ^5)\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.between_equal_dynamic/2","doc":"Builds a dynamic query where a field's value is between or equal to two provided values (inclusive).","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_equal_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.between_equal_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of two values representing the range.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_equal_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.between_equal_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.between_equal_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years >= ^2 and q.experience_years <= ^5)\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#between_equal_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.contains_any_dynamic/2","doc":"Builds a dynamic query where a JSONB field contains any of the provided values.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_any_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.contains_any_dynamic/2","doc":"- `key`       - The JSONB field name as an atom.\n  - `values`    - The values to check for overlap.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_any_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.contains_any_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.contains_any_dynamic(:tags, [\"elixir\", \"erlang\"])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"? && ?\\\", q.tags, ^[\\\"elixir\\\", \\\"erlang\\\"]))\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_any_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.contains_dynamic/2","doc":"Builds a dynamic query where a JSONB field contains a specific value.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.contains_dynamic/2","doc":"- `key`       - The JSONB field name as an atom.\n  - `value`     - The value to check for containment.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.contains_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.contains_dynamic(:metadata, %{\"role\" => \"admin\"})\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"? @> ?\\\", q.metadata, ^%{\\\"role\\\" => \\\"admin\\\"}))\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#contains_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.in_dynamic/2","doc":"Builds a dynamic query where a field's value is in a provided list.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#in_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.in_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of values to match against.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#in_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.in_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.in_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years in ^[2, 5])\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#in_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.not_between_dynamic/2","doc":"Builds a dynamic query where a field's value is not between the provided range (exclusive).","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.not_between_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of two values representing the range.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.not_between_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.not_between_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years < ^2 or q.experience_years > ^5)\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.not_between_equal_dynamic/2","doc":"Builds a dynamic query where a field's value is not between or equal to the provided range (inclusive).","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_equal_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.not_between_equal_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of two values representing the range.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_equal_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.not_between_equal_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.not_between_equal_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years <= ^2 or q.experience_years >= ^5)\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_between_equal_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.not_contains_any_dynamic/2","doc":"Builds a dynamic query where a JSONB field does not contain any of the provided values.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_any_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.not_contains_any_dynamic/2","doc":"- `key`       - The JSONB field name as an atom.\n  - `values`    - The values to check for absence.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_any_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.not_contains_any_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.not_contains_any_dynamic(:tags, [\"elixir\", \"erlang\"])\n    iex> inspect(result)\n    \"dynamic([q], not fragment(\\\"? && ?\\\", q.tags, ^[\\\"elixir\\\", \\\"erlang\\\"]))\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_any_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.not_contains_dynamic/2","doc":"Builds a dynamic query where a JSONB field does not contain a specific value.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.not_contains_dynamic/2","doc":"- `key`       - The JSONB field name as an atom.\n  - `value`     - The value to check for absence.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.not_contains_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.not_contains_dynamic(:metadata, %{\"role\" => \"admin\"})\n    iex> inspect(result)\n    \"dynamic([q], not fragment(\\\"? @> ?\\\", q.metadata, ^%{\\\"role\\\" => \\\"admin\\\"}))\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_contains_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.BtwInContains.not_in_dynamic/2","doc":"Builds a dynamic query where a field's value is not in the provided list.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_in_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.BtwInContains.not_in_dynamic/2","doc":"- `key`       - The field name as an atom.\n  - `values`    - A list of values to exclude.","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_in_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.BtwInContains.not_in_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.BtwInContains.not_in_dynamic(:experience_years, [2, 5])\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years not in ^[2, 5])\"","ref":"FatEcto.Query.Dynamics.BtwInContains.html#not_in_dynamic/2-examples"},{"type":"behaviour","title":"FatEcto.Query.Dynamics.Buildable","doc":"Builds queries after filtering fields based on user-provided filterable and overrideable fields.\n\nThis module provides functionality to filter Ecto queries using predefined filterable fields (handled by `Builder`)\nand overrideable fields (handled by a fallback function).","ref":"FatEcto.Query.Dynamics.Buildable.html"},{"type":"behaviour","title":"Options - FatEcto.Query.Dynamics.Buildable","doc":"- `filterable`: A map of fields and their allowed operators. Example:\n    [\n      id: [\"$EQUAL\", \"$NOT_EQUAL\"],\n      name: [\"$ILIKE\"]\n    ]\n- `overrideable`: A list of fields that can be overridden. Example:\n    [\"name\", \"phone\"]\n- `ignoreable`: A map of fields and their ignoreable values. Example:\n    [\n      \"name\" => [\"%%\", \"\", [], nil],\n      \"phone\" => [\"%%\", \"\", [], nil]\n    ]","ref":"FatEcto.Query.Dynamics.Buildable.html#module-options"},{"type":"behaviour","title":"Example Usage - FatEcto.Query.Dynamics.Buildable","doc":"defmodule FatEcto.HospitalDynamicsBuilder do\n      use FatEcto.Query.Dynamics.Buildable,\n        filterable: [\n          id: [\"$EQUAL\", \"$NOT_EQUAL\"]\n        ],\n        overrideable: [\"name\", \"phone\"],\n        ignoreable: [\n          name: [\"%%\", \"\", [], nil],\n          phone: [\"%%\", \"\", [], nil]\n        ]\n\n      import Ecto.Query\n\n      def override_buildable(\"name\", \"$ILIKE\", value) do\n        dynamic([q], ilike(fragment(\"(?)::TEXT\", q.name), ^value))\n      end\n\n      def override_buildable(\"phone\", \"$ILIKE\", value) do\n        dynamic([q], ilike(fragment(\"(?)::TEXT\", q.phone), ^value))\n      end\n\n      def override_buildable(_field, _operator, _value) do\n        nil\n      end\n\n      # Optional: Override after_buildable to perform custom processing on the final dynamics\n      def after_buildable(dynamics) do\n        IO.puts(\"Do something on final Dynamics\")\n        dynamics\n      end\n    end","ref":"FatEcto.Query.Dynamics.Buildable.html#module-example-usage"},{"type":"callback","title":"FatEcto.Query.Dynamics.Buildable.after_buildable/1","doc":"Callback for performing custom processing on the final dynamics.\n\nThis function is called at the end of the `build/2` function. The default behavior is to return the dynamics,\nbut it can be overridden by the using module.","ref":"FatEcto.Query.Dynamics.Buildable.html#c:after_buildable/1"},{"type":"callback","title":"FatEcto.Query.Dynamics.Buildable.override_buildable/3","doc":"Callback for handling custom filtering logic for overrideable fields.\n\nThis function acts as a fallback for overrideable fields. The default behavior is to return nil,\nbut it can be overridden by the using module.","ref":"FatEcto.Query.Dynamics.Buildable.html#c:override_buildable/3"},{"type":"module","title":"FatEcto.Query.Dynamics.Builder","doc":"Builds Ecto dynamic expressions from a structured query map.\nUsed by FatDynamicsBuildable for dynamic-only use cases.","ref":"FatEcto.Query.Dynamics.Builder.html"},{"type":"function","title":"FatEcto.Query.Dynamics.Builder.build/3","doc":"Builds an Ecto dynamic query from a JSON-like structure.","ref":"FatEcto.Query.Dynamics.Builder.html#build/3"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Builder.build/3","doc":"iex> import Ecto.Query\n    ...> query = FatEcto.Query.Dynamics.Builder.build(%{\n    ...>   \"$OR\" => [\n    ...>     %{\"name\" => \"John\"},\n    ...>     %{\"phone\" => nil},\n    ...>     %{\"age\" => %{\"$GT\" => 30}}\n    ...>   ]\n    ...> })\n    iex> inspect(query)\n    \"dynamic([q], q.name == ^\\\"John\\\" or is_nil(q.phone) or q.age > ^30)\"","ref":"FatEcto.Query.Dynamics.Builder.html#build/3-examples"},{"type":"module","title":"FatEcto.Query.Dynamics.GtLtEq","doc":"Provides dynamic query builders for common Ecto operations, such as filtering by comparison operators\n(`>`, `<`, `>=`, `<=`, `==`, `!=`) and handling `nil` values.\n\nThis module is designed to simplify the creation of dynamic queries for Ecto schemas, particularly\nwhen dealing with comparison-based filtering conditions.","ref":"FatEcto.Query.Dynamics.GtLtEq.html"},{"type":"module","title":"Example Usage - FatEcto.Query.Dynamics.GtLtEq","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.field_is_nil_dynamic(:location)\n    iex> inspect(result)\n    \"dynamic([q], is_nil(q.location))\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#module-example-usage"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.cast_to_date_eq_dynamic/2","doc":"Builds a dynamic query where a field cast to `date` is equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_eq_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_eq_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against (must be a `Date`).","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_eq_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_eq_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.cast_to_date_eq_dynamic(:end_date, ~D[2025-02-08])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"?::date\\\", q.end_date) == ^~D[2025-02-08])\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_eq_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gt_dynamic/2","doc":"Builds a dynamic query where a field cast to `date` is greater than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against (must be a `Date`).","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gt_dynamic(:end_date, ~D[2025-02-08])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"?::date\\\", q.end_date) > ^~D[2025-02-08])\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gte_dynamic/2","doc":"Builds a dynamic query where a field cast to `date` is greater than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against (must be a `Date`).","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.cast_to_date_gte_dynamic(:end_date, ~D[2025-02-08])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"?::date\\\", q.end_date) >= ^~D[2025-02-08])\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_gte_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lt_dynamic/2","doc":"Builds a dynamic query where a field cast to `date` is less than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against (must be a `Date`).","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lt_dynamic(:end_date, ~D[2025-02-08])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"?::date\\\", q.end_date) < ^~D[2025-02-08])\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lte_dynamic/2","doc":"Builds a dynamic query where a field cast to `date` is less than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against (must be a `Date`).","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.cast_to_date_lte_dynamic(:end_date, ~D[2025-02-08])\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"?::date\\\", q.end_date) <= ^~D[2025-02-08])\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#cast_to_date_lte_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.eq_dynamic/2","doc":"Builds a dynamic query where a field is equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#eq_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.eq_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#eq_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.eq_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.eq_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years == ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#eq_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.field_is_nil_dynamic/1","doc":"Builds a dynamic query where a field is `nil`.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#field_is_nil_dynamic/1"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.field_is_nil_dynamic/1","doc":"- `key` - The field name as an atom.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#field_is_nil_dynamic/1-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.field_is_nil_dynamic/1","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.field_is_nil_dynamic(:location)\n    iex> inspect(result)\n    \"dynamic([q], is_nil(q.location))\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#field_is_nil_dynamic/1-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.gt_dynamic/2","doc":"Builds a dynamic query where a field is greater than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.gt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.gt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.gt_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years > ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.gte_dynamic/2","doc":"Builds a dynamic query where a field is greater than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.gte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.gte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.gte_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years >= ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#gte_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.lt_dynamic/2","doc":"Builds a dynamic query where a field is less than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.lt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.lt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.lt_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years < ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.lte_dynamic/2","doc":"Builds a dynamic query where a field is less than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.lte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.lte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.lte_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years <= ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#lte_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_eq_dynamic/2","doc":"Builds a dynamic query where a field is not equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_eq_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_eq_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_eq_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_eq_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_eq_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years != ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_eq_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_field_is_nil_dynamic/1","doc":"Builds a dynamic query where a field is not `nil`.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_field_is_nil_dynamic/1"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_field_is_nil_dynamic/1","doc":"- `key` - The field name as an atom.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_field_is_nil_dynamic/1-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_field_is_nil_dynamic/1","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_field_is_nil_dynamic(:location)\n    iex> inspect(result)\n    \"dynamic([q], not is_nil(q.location))\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_field_is_nil_dynamic/1-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_gt_dynamic/2","doc":"Builds a dynamic query where a field is not greater than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_gt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_gt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_gt_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years <= ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_gte_dynamic/2","doc":"Builds a dynamic query where a field is not greater than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_gte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_gte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_gte_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years < ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_gte_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_lt_dynamic/2","doc":"Builds a dynamic query where a field is not less than a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lt_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_lt_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lt_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_lt_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_lt_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years >= ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lt_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.GtLtEq.not_lte_dynamic/2","doc":"Builds a dynamic query where a field is not less than or equal to a given value.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lte_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.GtLtEq.not_lte_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The value to compare against.","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lte_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.GtLtEq.not_lte_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.GtLtEq.not_lte_dynamic(:experience_years, 2)\n    iex> inspect(result)\n    \"dynamic([q], q.experience_years > ^2)\"","ref":"FatEcto.Query.Dynamics.GtLtEq.html#not_lte_dynamic/2-examples"},{"type":"module","title":"FatEcto.Query.Dynamics.Helper","doc":"Provides helper functions for Dynamics.","ref":"FatEcto.Query.Dynamics.Helper.html"},{"type":"function","title":"FatEcto.Query.Dynamics.Helper.merge_dynamics/3","doc":"Merges two dynamic expressions using the specified operator.\nIf either dynamic is nil, it returns the other dynamic.\nIf both are nil, it returns nil.\nThe operator can be `:and` or `:or`.","ref":"FatEcto.Query.Dynamics.Helper.html#merge_dynamics/3"},{"type":"module","title":"FatEcto.Query.Dynamics.Like","doc":"Provides dynamic query builders for filtering Ecto queries using `LIKE` and `ILIKE` operators.\n\nThis module is designed to simplify the creation of dynamic queries for Ecto schemas, particularly\nwhen dealing with pattern matching on text fields or arrays.","ref":"FatEcto.Query.Dynamics.Like.html"},{"type":"module","title":"Example Usage - FatEcto.Query.Dynamics.Like","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.ilike_dynamic(:name, \"%john%\")\n    iex> inspect(result)\n    \"dynamic([q], ilike(fragment(\\\"(?)::TEXT\\\", q.name), ^\\\"%john%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#module-example-usage"},{"type":"function","title":"FatEcto.Query.Dynamics.Like.array_ilike_dynamic/2","doc":"Builds a dynamic query where any element in an array field matches a substring (case-insensitive).","ref":"FatEcto.Query.Dynamics.Like.html#array_ilike_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.Like.array_ilike_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The substring to match (e.g., `\"%elixir%\"`).","ref":"FatEcto.Query.Dynamics.Like.html#array_ilike_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Like.array_ilike_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.array_ilike_dynamic(:tags, \"%elixir%\")\n    iex> inspect(result)\n    \"dynamic([q], fragment(\\\"EXISTS (SELECT 1 FROM UNNEST(?) as value WHERE value ILIKE ?)\\\", q.tags, ^\\\"%elixir%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#array_ilike_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.Like.ilike_dynamic/2","doc":"Builds a dynamic query where a field matches a substring (case-insensitive).","ref":"FatEcto.Query.Dynamics.Like.html#ilike_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.Like.ilike_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The substring to match (e.g., `\"%john%\"`).","ref":"FatEcto.Query.Dynamics.Like.html#ilike_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Like.ilike_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.ilike_dynamic(:name, \"%john%\")\n    iex> inspect(result)\n    \"dynamic([q], ilike(fragment(\\\"(?)::TEXT\\\", q.name), ^\\\"%john%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#ilike_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.Like.like_dynamic/2","doc":"Builds a dynamic query where a field matches a substring (case-sensitive).","ref":"FatEcto.Query.Dynamics.Like.html#like_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.Like.like_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The substring to match (e.g., `\"%John%\"`).","ref":"FatEcto.Query.Dynamics.Like.html#like_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Like.like_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.like_dynamic(:name, \"%John%\")\n    iex> inspect(result)\n    \"dynamic([q], like(fragment(\\\"(?)::TEXT\\\", q.name), ^\\\"%John%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#like_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.Like.not_ilike_dynamic/2","doc":"Builds a dynamic query where a field does not match a substring (case-insensitive).","ref":"FatEcto.Query.Dynamics.Like.html#not_ilike_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.Like.not_ilike_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The substring to exclude (e.g., `\"%john%\"`).","ref":"FatEcto.Query.Dynamics.Like.html#not_ilike_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Like.not_ilike_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.not_ilike_dynamic(:name, \"%john%\")\n    iex> inspect(result)\n    \"dynamic([q], not ilike(fragment(\\\"(?)::TEXT\\\", q.name), ^\\\"%john%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#not_ilike_dynamic/2-examples"},{"type":"function","title":"FatEcto.Query.Dynamics.Like.not_like_dynamic/2","doc":"Builds a dynamic query where a field does not match a substring (case-sensitive).","ref":"FatEcto.Query.Dynamics.Like.html#not_like_dynamic/2"},{"type":"function","title":"Parameters - FatEcto.Query.Dynamics.Like.not_like_dynamic/2","doc":"- `key` - The field name as an atom.\n  - `value` - The substring to exclude (e.g., `\"%John%\"`).","ref":"FatEcto.Query.Dynamics.Like.html#not_like_dynamic/2-parameters"},{"type":"function","title":"Examples - FatEcto.Query.Dynamics.Like.not_like_dynamic/2","doc":"iex> result = Elixir.FatEcto.Query.Dynamics.Like.not_like_dynamic(:name, \"%John%\")\n    iex> inspect(result)\n    \"dynamic([q], not like(fragment(\\\"(?)::TEXT\\\", q.name), ^\\\"%John%\\\"))\"","ref":"FatEcto.Query.Dynamics.Like.html#not_like_dynamic/2-examples"},{"type":"module","title":"FatEcto.Query.Helper","doc":"Provides helper functions for filtering and processing query parameters in `FatEcto.Query.Dynamics.Buildable`.","ref":"FatEcto.Query.Helper.html"},{"type":"function","title":"FatEcto.Query.Helper.filter_filterable_fields/3","doc":"Filters fields based on the `filterable_fields` configuration.","ref":"FatEcto.Query.Helper.html#filter_filterable_fields/3"},{"type":"function","title":"Parameters - FatEcto.Query.Helper.filter_filterable_fields/3","doc":"- `where_params`: The query parameters (e.g., `%{\"field\" => %{\"$EQUAL\" => \"value\"}}`).\n  - `filterable_fields`: A keyword list of fields and their allowed operators (e.g., `[name: [\"$EQUAL\"], age: \"*\"]`).\n  - `overrideable_fields`: A list of fields that can be overridden (e.g., `[\"phone\"]`).","ref":"FatEcto.Query.Helper.html#filter_filterable_fields/3-parameters"},{"type":"function","title":"Returns - FatEcto.Query.Helper.filter_filterable_fields/3","doc":"- The filtered query parameters.","ref":"FatEcto.Query.Helper.html#filter_filterable_fields/3-returns"},{"type":"function","title":"FatEcto.Query.Helper.remove_ignoreable_fields/2","doc":"Removes fields with ignoreable values from the query parameters.","ref":"FatEcto.Query.Helper.html#remove_ignoreable_fields/2"},{"type":"function","title":"Parameters - FatEcto.Query.Helper.remove_ignoreable_fields/2","doc":"- `where_params`: The query parameters (e.g., `%{\"field\" => %{\"$EQUAL\" => \"value\"}}`).\n  - `ignoreable_fields_values`: A keyword list of fields and their ignoreable values (e.g., `[email: [\"\", \"%%\", nil], phone: [nil]]`).","ref":"FatEcto.Query.Helper.html#remove_ignoreable_fields/2-parameters"},{"type":"function","title":"Returns - FatEcto.Query.Helper.remove_ignoreable_fields/2","doc":"- The filtered query parameters.","ref":"FatEcto.Query.Helper.html#remove_ignoreable_fields/2-returns"},{"type":"module","title":"FatEcto.Query.OperatorApplier","doc":"Provides helper functions to apply dynamic query operators for Ecto queries.\n\nThis module centralizes the logic for applying various query operators such as `$LIKE`, `$ILIKE`, `$LT`, `$GT`, etc.,\nas well as their negated counterparts (e.g., `$NOT_LIKE`, `$NOT_ILIKE`). It is designed to work with `FatDynamics` and\n`FatNotDynamics` modules to generate dynamic Ecto query conditions.","ref":"FatEcto.Query.OperatorApplier.html"},{"type":"module","title":"Supported Operators - FatEcto.Query.OperatorApplier","doc":"","ref":"FatEcto.Query.OperatorApplier.html#module-supported-operators"},{"type":"module","title":"Positive Operators - FatEcto.Query.OperatorApplier","doc":"- `$LIKE`: Matches a pattern in a string.\n- `$NOT_LIKE`: Excludes rows that match a pattern in a string.\n- `$ILIKE`: Case-insensitive match of a pattern in a string.\n- `$NOT_ILIKE`: Case-insensitive exclusion of rows that match a pattern in a string.\n- `$LT`: Less than.\n- `$LTE`: Less than or equal to.\n- `$GT`: Greater than.\n- `$GTE`: Greater than or equal to.\n- `$BETWEEN`: Matches values between a range (exclusive).\n- `$BETWEEN_EQUAL`: Matches values between a range (inclusive).\n- `$NOT_BETWEEN`: Excludes values between a range (exclusive).\n- `$NOT_BETWEEN_EQUAL`: Excludes values between a range (inclusive).\n- `$IN`: Matches values in a list.\n- `$NOT_IN`: Excludes values in a list.\n- `$EQUAL`: Matches a specific value.\n- `$NOT_EQUAL`: Excludes a specific value.","ref":"FatEcto.Query.OperatorApplier.html#module-positive-operators"},{"type":"module","title":"Negated Operators (for `$NOT` conditions) - FatEcto.Query.OperatorApplier","doc":"- `$LIKE`: Negates the `$LIKE` condition.\n- `$ILIKE`: Negates the `$ILIKE` condition.\n- `$LT`: Negates the `$LT` condition.\n- `$LTE`: Negates the `$LTE` condition.\n- `$GT`: Negates the `$GT` condition.\n- `$GTE`: Negates the `$GTE` condition.\n- `$EQUAL`: Negates the `$EQUAL` condition.","ref":"FatEcto.Query.OperatorApplier.html#module-negated-operators-for-not-conditions"},{"type":"module","title":"Usage - FatEcto.Query.OperatorApplier","doc":"This module is typically used internally by `FatEcto.FatQuery.FatWhere` and `FatEcto.FatQuery.WhereOr` to construct\ndynamic queries. It abstracts away the complexity of applying operators and ensures consistency across the codebase.","ref":"FatEcto.Query.OperatorApplier.html#module-usage"},{"type":"module","title":"Example - FatEcto.Query.OperatorApplier","doc":"# Applying a `$LIKE` operator\n    OperatorApplier.apply_operator(\"$LIKE\", :name, \"%John%\", [])\n\n    # Applying a negated `$EQUAL` operator\n    OperatorApplier.apply_not_condition(\"$EQUAL\", :age, 30, [])","ref":"FatEcto.Query.OperatorApplier.html#module-example"},{"type":"function","title":"FatEcto.Query.OperatorApplier.allowed_not_operators/0","doc":"","ref":"FatEcto.Query.OperatorApplier.html#allowed_not_operators/0"},{"type":"function","title":"FatEcto.Query.OperatorApplier.allowed_operators/0","doc":"","ref":"FatEcto.Query.OperatorApplier.html#allowed_operators/0"},{"type":"function","title":"FatEcto.Query.OperatorApplier.apply_nil_operator/2","doc":"","ref":"FatEcto.Query.OperatorApplier.html#apply_nil_operator/2"},{"type":"function","title":"FatEcto.Query.OperatorApplier.apply_not_condition/3","doc":"","ref":"FatEcto.Query.OperatorApplier.html#apply_not_condition/3"},{"type":"function","title":"FatEcto.Query.OperatorApplier.apply_operator/3","doc":"","ref":"FatEcto.Query.OperatorApplier.html#apply_operator/3"},{"type":"module","title":"FatEcto.SharedHelper","doc":"Provides utility functions for FatEcto, including handling pagination limits, skip values,\ndynamic binding, and preloading associations.","ref":"FatEcto.SharedHelper.html"},{"type":"function","title":"FatEcto.SharedHelper.filterable_opt_to_map/1","doc":"","ref":"FatEcto.SharedHelper.html#filterable_opt_to_map/1"},{"type":"function","title":"FatEcto.SharedHelper.get_primary_keys/1","doc":"Retrieves the primary keys for a given query.","ref":"FatEcto.SharedHelper.html#get_primary_keys/1"},{"type":"function","title":"Parameters - FatEcto.SharedHelper.get_primary_keys/1","doc":"- `query`: The Ecto query.","ref":"FatEcto.SharedHelper.html#get_primary_keys/1-parameters"},{"type":"function","title":"Examples - FatEcto.SharedHelper.get_primary_keys/1","doc":"iex> FatEcto.SharedHelper.get_primary_keys(from(u in User))\n    [:id]","ref":"FatEcto.SharedHelper.html#get_primary_keys/1-examples"},{"type":"function","title":"FatEcto.SharedHelper.implements_behaviour?/2","doc":"Checks if a module implements the given behaviour by inspecting its `__info__/1` metadata.","ref":"FatEcto.SharedHelper.html#implements_behaviour?/2"},{"type":"function","title":"Parameters - FatEcto.SharedHelper.implements_behaviour?/2","doc":"- `module`: The module to check.\n- `behaviour`: The behaviour to validate against.","ref":"FatEcto.SharedHelper.html#implements_behaviour?/2-parameters"},{"type":"function","title":"Examples - FatEcto.SharedHelper.implements_behaviour?/2","doc":"iex> implements_behaviour?(MyApp.Repo, Ecto.Repo)\n    true\n\n    iex> implements_behaviour?(NotARepo, Ecto.Repo)\n    false","ref":"FatEcto.SharedHelper.html#implements_behaviour?/2-examples"},{"type":"function","title":"FatEcto.SharedHelper.keyword_list_to_map/1","doc":"","ref":"FatEcto.SharedHelper.html#keyword_list_to_map/1"},{"type":"function","title":"FatEcto.SharedHelper.parse_integer!/1","doc":"Parses an integer from a string or returns the integer if already an integer.\n\nReturns the parsed integer on success or `nil` on failure.","ref":"FatEcto.SharedHelper.html#parse_integer!/1"},{"type":"function","title":"FatEcto.SharedHelper.string_to_atom/1","doc":"Converts a string to an atom.","ref":"FatEcto.SharedHelper.html#string_to_atom/1"},{"type":"function","title":"Parameters - FatEcto.SharedHelper.string_to_atom/1","doc":"- `str`: The string to convert.","ref":"FatEcto.SharedHelper.html#string_to_atom/1-parameters"},{"type":"function","title":"Examples - FatEcto.SharedHelper.string_to_atom/1","doc":"iex> FatEcto.SharedHelper.string_to_atom(\"example\")\n    :example","ref":"FatEcto.SharedHelper.html#string_to_atom/1-examples"},{"type":"function","title":"FatEcto.SharedHelper.string_to_existing_atom/1","doc":"Converts a string to an existing atom.","ref":"FatEcto.SharedHelper.html#string_to_existing_atom/1"},{"type":"function","title":"Parameters - FatEcto.SharedHelper.string_to_existing_atom/1","doc":"- `str`: The string to convert.","ref":"FatEcto.SharedHelper.html#string_to_existing_atom/1-parameters"},{"type":"function","title":"Examples - FatEcto.SharedHelper.string_to_existing_atom/1","doc":"iex> FatEcto.SharedHelper.string_to_existing_atom(\"example\")\n    :example","ref":"FatEcto.SharedHelper.html#string_to_existing_atom/1-examples"},{"type":"module","title":"FatEcto.Sort.Helper","doc":"Provides helper functions for sorting query parameters.","ref":"FatEcto.Sort.Helper.html"},{"type":"function","title":"FatEcto.Sort.Helper.filter_sortable_fields/2","doc":"Filters sortable fields based on the provided `sortable_fields` map.","ref":"FatEcto.Sort.Helper.html#filter_sortable_fields/2"},{"type":"function","title":"Parameters - FatEcto.Sort.Helper.filter_sortable_fields/2","doc":"- `filtered_params`: A map of fields and their sorting operators.\n  - `sortable_fields`: A map of allowed fields and their corresponding operators.","ref":"FatEcto.Sort.Helper.html#filter_sortable_fields/2-parameters"},{"type":"function","title":"Returns - FatEcto.Sort.Helper.filter_sortable_fields/2","doc":"- A filtered map containing only the fields and operators that are allowed.","ref":"FatEcto.Sort.Helper.html#filter_sortable_fields/2-returns"},{"type":"behaviour","title":"FatEcto.Sort.Sortable","doc":"Provides functionality to define sortable fields with override support.","ref":"FatEcto.Sort.Sortable.html"},{"type":"behaviour","title":"Example Usage - FatEcto.Sort.Sortable","doc":"defmodule MyApp.UserSort do\n      use FatEcto.Sort.Sortable,\n        sortable: [email: \"*\", name: [\"$ASC\", \"$DESC\"]],\n        overrideable: [\"custom_field\"]\n\n      @impl true\n      def override_sortable(\"custom_field\", \"$ASC\") do\n        {:asc, dynamic([u], fragment(\"?->>'custom_field'\", u.metadata))}\n      end\n\n      def override_sortable(\"custom_field\", \"$DESC\") do\n        {:desc, dynamic([u], fragment(\"?->>'custom_field'\", u.metadata))}\n      end\n\n      def override_sortable(_field, _operator) do\n        nil\n      end\n    end\n\n    # Usage:\n    order_by = MyApp.UserSort.build(%{\"email\" => \"$DESC\", \"custom_field\" => \"$ASC\"})\n    query = from(u in User, order_by: ^order_by)","ref":"FatEcto.Sort.Sortable.html#module-example-usage"},{"type":"callback","title":"FatEcto.Sort.Sortable.override_sortable/2","doc":"Callback for handling custom sorting logic.\n\nShould return `{direction, dynamic}` tuple or nil if not handling the field.","ref":"FatEcto.Sort.Sortable.html#c:override_sortable/2"},{"type":"module","title":"FatEcto.Sort.Sorter","doc":"Builds order_by expressions in the format Ecto expects.","ref":"FatEcto.Sort.Sorter.html"},{"type":"function","title":"FatEcto.Sort.Sorter.build_order_by/1","doc":"Builds order expressions from parameters.","ref":"FatEcto.Sort.Sorter.html#build_order_by/1"},{"type":"type","title":"FatEcto.Sort.Sorter.order_expr/0","doc":"","ref":"FatEcto.Sort.Sorter.html#t:order_expr/0"},{"type":"extras","title":"FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"# FatEcto: Supercharge Your Ecto Queries with Ease! 🚀\n\n[![Build Status](https://github.com/tanweerdev/fat_ecto/actions/workflows/fat_ecto.yml/badge.svg)](https://github.com/tanweerdev/fat_ecto/actions)\n[![Coverage Status](https://coveralls.io/repos/github/tanweerdev/fat_ecto/badge.svg)](https://coveralls.io/github/tanweerdev/fat_ecto)\n[![hex.pm version](https://img.shields.io/hexpm/v/fat_ecto.svg)](https://hex.pm/packages/fat_ecto)\n[![hex.pm downloads](https://img.shields.io/hexpm/dt/fat_ecto.svg)](https://hex.pm/packages/fat_ecto)\n[![hex.pm license](https://img.shields.io/hexpm/l/fat_ecto.svg)](https://github.com/tanweerdev/fat_ecto/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/tanweerdev/fat_ecto.svg)](https://github.com/tanweerdev/fat_ecto/commits/master)\n\n---","ref":"readme.html"},{"type":"extras","title":"Description - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"FatEcto is an Elixir package designed to make your life easier when working with Ecto. It simplifies query building, filtering, sorting, and pagination—so you can focus on what truly matters: building amazing applications. With FatEcto, writing complex repeating queries becomes effortless, flexible, and powerful! 💪\n\n---","ref":"readme.html#description"},{"type":"extras","title":"Installation - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"Add `fat_ecto` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    # Check https://hexdocs.pm/fat_ecto for the latest version\n    {:fat_ecto, \"~> 1.2\"}\n  ]\nend\n```\n\nThen, run `mix deps.get` to install the package.\n\n---","ref":"readme.html#installation"},{"type":"extras","title":"Features & Modules - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"","ref":"readme.html#features-modules"},{"type":"extras","title":"🛠 FatEcto.Query.Dynamics.Buildable – Dynamic Filtering Made Easy - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"Tired of writing repetitive query filters? The `Whereable` module lets you dynamically filter records using flexible conditions passed from your web or mobile clients—with little to no effort! And the best part? You stay in control. 🚀\n\n#### Usage\n\n```elixir\ndefmodule FatEcto.HospitalDynamicsBuilder do\n  use FatEcto.Query.Dynamics.Buildable,\n    filterable: [\n      id: [\"$EQUAL\", \"$NOT_EQUAL\"]\n    ],\n    overrideable: [\"name\", \"phone\"],\n    ignoreable: [\n      name: [\"%%\", \"\", [], nil],\n      phone: [\"%%\", \"\", [], nil]\n    ]\n\n  import Ecto.Query\n\n  @impl true\n  # You can implement override_buildable for your custom filters\n  def override_buildable(\"name\", \"$ILIKE\", value) do\n    dynamic([r], ilike(fragment(\"(?)::TEXT\", r.name), ^value))\n  end\n\n  def override_buildable(_field, _operator, _value), do: nil\nend\n```\n\n---\n\n#### Example Usage\n\nHere are some practical examples of how to use `FatEcto.HospitalDynamicsBuilder` to dynamically build queries:\n\n##### Example 1: Basic Filtering by ID\n\n```elixir\n# Filter hospitals with ID equal to 1\nparams = %{\"id\" => %{\"$EQUAL\" => 1}}\ndynamics = FatEcto.HospitalDynamicsBuilder.build(params)\n\n# Use the dynamics in a query\nimport Ecto.Query\nquery = where(FatEcto.FatHospital, ^dynamics)\n\n# Resulting query:\n# from(h in FatEcto.FatHospital, where: h.id == 1)\n```\n\n##### Example 2: Case-Insensitive Name Search\n\n```elixir\n# Filter hospitals with names containing \"St. Mary\"\nparams = %{\"name\" => %{\"$ILIKE\" => \"%St. Mary%\"}}\ndynamics = FatEcto.HospitalDynamicsBuilder.build(params)\n\n# Use the dynamics in a query\nimport Ecto.Query\nquery = where(FatEcto.FatHospital, ^dynamics)\n\n# Resulting query:\n# from(h in FatEcto.FatHospital, where: ilike(fragment(\"(?)::TEXT\", h.name), ^\"%St. Mary%\"))\n```\n\n##### Example 3: Combining Multiple Filters\n\n```elixir\n# Filter hospitals with ID not equal to 2 AND name containing \"General\"\nparams = %{\n  \"id\" => %{\"$NOT_EQUAL\" => 2},\n  \"name\" => %{\"$ILIKE\" => \"%General%\"}\n}\ndynamics = FatEcto.HospitalDynamicsBuilder.build(params)\n\n# Use the dynamics in a query\nimport Ecto.Query\nquery = where(FatEcto.FatHospital, ^dynamics)\n\n# Resulting query:\n# from(h in FatEcto.FatHospital, where: h.id != 2 and ilike(fragment(\"(?)::TEXT\", h.name), ^\"%General%\"))\n```\n\n##### Example 4: Ignoring Empty or Invalid Values\n\n```elixir\n# Filter hospitals with a name, but ignore empty or invalid values\nparams = %{\"name\" => %{\"$ILIKE\" => \"%%\"}}  # Empty value is ignored\ndynamics = FatEcto.HospitalDynamicsBuilder.build(params)\n\n# Use the dynamics in a query\nimport Ecto.Query\nquery = where(FatEcto.FatHospital, ^dynamics)\n\n# Resulting query:\n# from(h in FatEcto.FatHospital)  # No filtering applied for name\n```\n\n##### Example 5: Even Complex Nested conditions\n\n```elixir\n# Filter hospitals with a name, but ignore empty or invalid values\nparams = %{\n  \"$OR\" => [\n    %{\n      \"name\" => %{\"$ILIKE\" => \"%John%\"},\n      \"$OR\" => %{\"rating\" => %{\"$GT\" => 18}, \"location\" => \"New York\"}\n    },\n    %{\n      \"start_date\" => \"2023-01-01\",\n      \"$AND\" => [\n        %{\"rating\" => %{\"$GT\" => 4}},\n        %{\"email\" => \"fat_ecto@example.com\"}\n      ]\n    }\n  ]\n}\n\ndynamics = DoctorFilter.build(params)\n\n# Resulting dynamic:\ndynamic(\n  [q],\n  ((q.location == ^\"New York\" or q.rating > ^18) and ilike(fragment(\"(?)::TEXT\", q.name), ^\"%John%\")) or\n    (q.rating > ^4 and q.email == ^\"fat_ecto@example.com\" and q.start_date == ^\"2023-01-01\")\n)\n\n# You can now apply the result on where just like above examples\n```\n\n---","ref":"readme.html#fatecto-query-dynamics-buildable-dynamic-filtering-made-easy"},{"type":"extras","title":"🔄 FatEcto.Sort.Sortable – Effortless Sorting - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"Sorting should be simple—and with `Sortable`, it is! Your frontend can send sorting parameters, and FatEcto will seamlessly generate the right sorting queries, allowing you to build powerful, customizable sorting logic without breaking a sweat. 😎\n\n#### Usage of FatSortable\n\n```elixir\ndefmodule Fat.SortQuery do\n  import Ecto.Query\n  use FatEcto.Sort.Sortable,\n    sortable: [id: \"$ASC\", email: \"*\", name: [\"$ASC\", \"$DESC\"]],\n    overrideable: [\"custom_field\"]\n\n  @impl true\n  def override_sortable(\"custom_field\", \"$DESC\") do\n    {:desc, dynamic([u], fragment(\"?->>'custom_field'\", u.metadata))}\n  end\n\n  def override_sortable(_field, _operator), do: nil\nend\n```\n\n---","ref":"readme.html#fatecto-sort-sortable-effortless-sorting"},{"type":"extras","title":"📌 FatEcto.Pagination.Paginator – Paginate Like a Pro - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"No more hassle with pagination! FatPaginator helps you paginate Ecto queries efficiently, keeping your APIs snappy and responsive.\n\n#### Usage of FatPaginator\n\n```elixir\ndefmodule Fat.MyPaginator do\n  use FatEcto.Pagination.V2Paginator,\n    default_limit: 10,\n    repo: FatEcto.Repo,\n    max_limit: 100\nend\n```\n\n---","ref":"readme.html#fatecto-pagination-paginator-paginate-like-a-pro"},{"type":"extras","title":"🚀 Contributing - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"We love contributions! If you’d like to improve FatEcto, submit an issue or pull request. Let’s build something amazing together! 🔥\n\n---","ref":"readme.html#contributing"},{"type":"extras","title":"📜 License - FatEcto: Supercharge Your Ecto Queries with Ease! 🚀","doc":"FatEcto is released under the MIT License.\n\n📖 See the full documentation at [HexDocs](https://hexdocs.pm/fat_ecto/) for more details.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}